/***************************************************************************************
* server.h
*
* hlavickovy soubor pro server a pomocne programy k aplikaci 
* virtualni sitova laborator, diplomove praci 
*
* autor: Pavel Nemec, nem114
* 
* VSB-TU Ostrava, FEI, 2005
*
****************************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/select.h>
#include <time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <string.h>
#include <sys/wait.h>

// dulezite pro funkce z mysql
#if defined(USE_DB)
#include "mysql/mysql.h"
#endif

/*   server linux456.vsb.cz  */
/*#define DB_SERVER_IP "158.196.246.18"
#define DB_SERVER_IP "158.196.246.18"
char *user = "nem114";
char *ps = "nem114";
char *db = "nem114";
*/

// WWW adresa korene virtlabu
char *www = "http://virtlab.cs.vsb.cz";
// testovaci
// char *www = "http://virtlab.vsb.cz/virtlab";

/*   localhost  */
#define DB_SERVER_IP "localhost"
char *user = "user_vnl";
char *ps = "heslo_vnl";
char *db = "virt_net_laboratory";
char *server_log_file = "/usr/virtlab/log/server_log_file";
// Pripojovani TCP spojeni na conserver
char *users_log_file = "/usr/virtlab/log/users_log_file";
// Dump znaku do a z routeru od uzivatele (MAZAT!)
char *hello_msg = "\n\n******************************\nHello, here is Virtlab server.\n******************************\nPress ENTER multiple times to get access to desired device\n\n";

const long test_user = 99991;

//cesta k certifikatu
char *CertFile = "/usr/virtlab/bin/keys/ca.crt";
//cesta k privatnimu klici
char *KeyFile = "/usr/virtlab/bin/keys/ca.key";


/* promenna se seriovym rozhranim */
const char *devttyS = "/dev/ttyM";

const char *devttyTATA = "/dev/ttyS0";

#define MAX_NOACTIVITY_TIME 10

#define BAUDRATE B9600
#define BAUDRATE2 B19200
#define SOCKET_A 10000
#define SOCKET_B 10001

#define EXIT_FAILURE -1

#define MAX(a,b) ((a) < (b) ? (a) : (b))

/* Kody pro komunikacni protokol */ 
const char SI = '1';
const char COM_PORT	= '2';
const char MAX_LEASE_TIME = '3';

const char AUTH_USER_OK	= '4';
const char OK_COM_PORT	= '5';
const char OK_MAX_LEASE_TIME = '6';

const char NOT_AUTH_USER= 101;

const char OK_SI 	= '4';
const char NOT_OK	= '2';

const char ID_ZAR 	= '3';
const char OK_ID_ZAR 	= '4';

const char DISCONNECT_EVENT = 7;
const char TUTOR_EVENT = 8;


const char NOT_COM_PORT = 108;

const char DATA	= 100;

const char DISCONNECT_NOACTIVITY = 17;
const char TIME_EXCEEDED = 18;
const char DISCONNECT_AFTER_10_MIN = 19;
const char DISCONNECT_AFTER_5_MIN = 20;
const char DISCONNECT_AFTER_1_MIN = 21;

const char TUTOR_CONNECT = 23;
const char TUTOR_DISCONNECT = 24;
const char TUTOR_CONNECT_VISIBLE = 25;
/* maximalni cislo serioveho portu, ktere je mozno otevrit v systemu */
const unsigned short MAX_COM_PORT = 16;

