/* **************************************************

Rozsireni virtualni sitove laboratore

diplomova prace
VSB-TU Ostrava, katedra Informatiky
autor: Roman Kubin, Petr Grygarek, Jiri Dvorak, 2006


*******************************************************
Program nacte z prikazoveho radku jmeno ovladace serioveho
portu, kde je pripojeno spojovaci zarizeni a jmeno
souboru, ktery na konzolu spojovaciho zarizeni posle.
Je mozne zadat hostname:port misto souboru ovladace, v tom pripade
posila do TCP spojeni.
Dalsim parametrem je pocet ms cekani mezi znaky (kvuli Tatabazmeku
a nekompatibilite flow control s Linuxovym seriovym portem)
Podporuje prikaz {WAIT}A
*****************************************************/

// #define DEBUG

#include "server.h"
#include <assert.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <errno.h>
#include <stdio.h>

extern int errno;

int main(int argc, char *argv[]){
	char *init_commands;
	char *init_commands_part,*p;
	char temp[3];
	int fd, fd_cfg, wait_ms, i, l;
	struct stat st;

	//parsovani parametru prikazove radky
	if(argc != 4) {
		printf("Program se spousti s parametry:\n   jmeno_souboru_ovladace_com_portu|ip_addr:port jmeno_souboru_pro_upload ms_mezi_znaky\n");
		return(-1);
	}

	if (sscanf(argv[3],"%d",&wait_ms)!=1) {
		printf("Chybne zadana doba cekani mezi znaky\n");
		return -1;
	}

	// otevru config soubor a kvuli nasledne tokenizaci nactu cely do pameti
	if((fd_cfg = open(argv[2], O_RDWR))==-1) {
			printf ("Chyba otevirani souboru s konfiguraci: %d\n", errno);
			exit(-1);
	}
	if (fstat(fd_cfg,&st)==-1) {
			printf ("Chyba fstat: %d\n", errno);
			exit(-1);
	}
	init_commands=(char*) malloc(st.st_size);
	assert(init_commands!=NULL);
	read(fd_cfg,init_commands,st.st_size);
	close(fd_cfg);


#ifdef DEBUG
	printf("Delka uploadovaneho souboru: %d\n",st.st_size);
	printf("Doba cekani mezi znaky: %d [ms]\n",wait_ms);
#endif
	
	if ((p=strchr(argv[1],':'))!=NULL) {
	 // jde o TCP spojeni - misto souboru ovladace zadan host:port
#ifdef DEBUG
	printf("Otevira se TCP spojeni\n");
#endif
	 
	 struct sockaddr_in saMy,saHis;
	 int port;
	 struct linger lg;

	 if ((fd=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP))==-1)
  	  { printf("Chyba otevirani socketu: %d\n",errno); return -1; }

	 // Nastavime linger option, aby pred close() vyslal data z bufferu
	 // (ale zda se, ze to stejne nefunguje)
	 lg.l_onoff=1;
	 lg.l_linger=30*100;
	  // na Linuxu patrne udavano v setinach sekund
	 if (setsockopt(fd,SOL_SOCKET,SO_LINGER,&lg,sizeof(struct linger))==-1)
  	  { printf("Chyba setsockopt(LINGER): %d\n",errno); return -1; }

	 // pripravime lokalni adresu
	 saMy.sin_family=AF_INET;
	 saMy.sin_port=0;
	 saMy.sin_addr.s_addr=INADDR_ANY;
	  // ZDE BUDE MOZNA TREBA DAT ADRESU KONKRETNI SITOVE KARTY
	 
	 // svazeme lokalni adresu se socketem
	 if (bind(fd,(struct sockaddr*)&saMy,sizeof(saMy))==-1)
	  { printf("Chyba bind: %d\n",errno); close(fd); exit(-1); }

	 // pripravime adresu serveru (z prikazoveho radku)
	 *p=0;
	 if (sscanf(p+1,"%d",&port)!=1)
	  { printf("Chybny port"); close(fd); exit(-1); }

	 saHis.sin_family=AF_INET;
  	 saHis.sin_port=htons(port);
  	 saHis.sin_addr.s_addr=inet_addr(argv[1]);
         if (saHis.sin_addr.s_addr==-1)
	   { printf("Cannot parse remote host IP address\n"); close(fd);
	     exit(-1); }

        // navazeme spojeni se serverem
	
	 if (connect(fd,(struct sockaddr*)&saHis,sizeof(saHis))==-1)
	   { printf("Cannot connect to the remote host\n"); close(fd);
	     exit(-1); }
	}
	 // Jde o soubor ovladace serioveho portu
	 else if ((fd = open(argv[1], O_RDWR | O_NOCTTY))==-1) {
		  printf("Chyba otevirani souboru ovladace com portu: %d\n",errno);
		  return -1;
	      }

	// zapisu do serioveho rozhrani | TCP inicializacni prikazy
		printf("Konfigurace se posila do spojovaciho zarizeni.\nProsim cekejte.\n");

		init_commands_part = strtok(init_commands, "\n");
		char posli[200];
		while(init_commands_part) {
#ifdef DEBUG
		printf("I: %s\n",init_commands_part);
#endif
			if(strstr(init_commands_part, "{WAIT"))	{
				if(init_commands_part[7] != '\0' && init_commands_part[7] != '\n') {
					temp[0] = init_commands_part[6];
					temp[1] = init_commands_part[7];
					temp[2] = '\0';
				}
				else {
					temp[0] = init_commands_part[6];
					temp[1] = '\0';
				}
				sleep(atoi(temp));
				init_commands_part = strtok(NULL, "\n");
				continue;
			}// WAIT
			else if(strstr(init_commands_part, "{^Z}"))
				sprintf(posli, "\x1a\r\n");
			else if(strstr(init_commands_part, "{ENTER}"))
				sprintf(posli, "\r\n");
			//zapis prikazu na port
			else sprintf(posli, "%s\n", init_commands_part);

#ifdef DEBUG
			printf("O: ");
#endif
			l=strlen(posli);
			for (i=0; i<l; i++) {
			 if(write(fd, posli+i,1)<=0) {
				printf("Chyba pri zapisu na zarizeni %s !\n",
						argv[1]);
				return -1;
			 }
#ifdef DEBUG
			printf("%c",*(posli+i));
#endif
		 	if (wait_ms>0) usleep(wait_ms*1000);
			}

			init_commands_part = strtok(NULL, "\n");
		}// while
		close(fd);
		free(init_commands);
		printf("Soubor byl zapsan na zarizeni.\n");
	return 0;
}
